#!/usr/bin/env python
import urllib2, time, os, datetime

def get_times():
    """
    This method records data from onebusaway. It creates/appends a log file
    and records predicted arrival and scheduled arrival for buses that have 
    reached their stop. Currently this method only records data from stop#
    29227.
    """
    os.chdir('/') # set this to the directory you want to store data log.
    f = file('oba.txt', 'a')
    while True:
        metro_time = urllib2.urlopen('http://api.onebusaway.org/api/where/current-time.xml?key=TEST').readlines()
        metro_time = xml_to_time(metro_time[5])
        page = urllib2.urlopen('http://api.onebusaway.org/api/where/arrivals-and-departures-for-stop/1_29227.xml?key=TEST')
        data = page.readlines()
        for i in xrange(len(data)):
            data[i] = data[i].strip()
            if data[i].startswith('<predictedArrivalTime>') and (0 < xml_to_time(data[i]) < metro_time):
                f.write(data[i-3])
                f.write(data[i])
                f.write(data[i+1].strip() + '\n')
        f.flush()
        print metro_time
        time.sleep(180)  #might need adjusting?
    f.close()

def get_range(filename, start, end):
    start = time.mktime(time.struct_time((2010, 6, 1, start[0], start[1], 0, 1, 152, 1)))
    end = time.mktime(time.struct_time((2010, 6, 1, end[0], end[1], 0, 1, 152, 1)))
    f = open(filename, 'r')
    dict = {}
    for line in f:
        key = int(line.split(' ')[1])
        if start <= key < end:
            print 'asdfsa'
            dict[key] = int(line.split(' ')[2].rstrip())
    return dict


def xml_to_time(string, local = False):
    """
    Takes xml tag and parses it to for an integer.
    """
    num = string.partition('>')[2].partition('<')
    if local:
        return str(time.localtime(int(num[0]) / 1000))
    return int(num[0])

def parse_id(string):
    return string.partition('tripId>')[2].partition('</tripId')[0]

def time_diff(string):
    predicted = string.partition('predictedArrivalTime>')[2].partition('</predicted')[0]
    scheduled = string.partition('scheduledArrivalTime>')[2].partition('</scheduled')[0]
    return (int(scheduled), int(scheduled) - int(predicted))

def read_log(filename):
    """
    Takes absolute path to log file as argument. Parses log file and
    returns stuff.
    """
    f = open(filename, 'r')
    for line in f:
        parse_xml(line)
    

if __name__ == '__main__':
#    get_times()
    print get_range('/obadata.txt',(9,0), (12,0))
